#ifndef _FTAPE_BSM_H
#define _FTAPE_BSM_H

/*
 * Copyright (C) 1994-1995 Bas Laarhoven.

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2, or (at your option)
any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; see the file COPYING.  If not, write to
the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.

 *
 $Source: /homes/cvs/zftape/ftape-bsm.h,v $
 $Author: claus $
 *
 $Revision: 1.8 $
 $Date: 1995/12/07 15:39:45 $
 $State: Exp $
 *
 *      This file contains definitions for the bad sector map handling
 *      routines for the QIC-117 floppy-tape driver for Linux.
 */

#include "ftape.h"
#include "zftape-buffers.h"

typedef __u32 SectorMap;
typedef unsigned SectorType; /* should occupy only 24 bits, but ...
			 * as calculations are done with this quantity, it is probably the
			 * fastest method to declare this to be the natural integer size
			 */

#define EMPTY_SEGMENT           ((SectorMap)0xffffffff)
#define FAKE_SEGMENT            ((SectorMap)0xfffffffe)

/*  maximum (format code 4) bad sector map size (bytes).
 */
#define BAD_SECTOR_MAP_SIZE     (29 * SECTOR_SIZE - 256)

/*
 *      ftape-io.c defined global vars.
 */
extern int bad_sector_map_changed;                  
DECLARE_BUFFER(byte, bad_sector_map, BAD_SECTOR_MAP_SIZE);
/*
 *      ftape-io.c defined global functions.
 */
extern void store_bad_sector_map( byte* buffer);
extern int extract_bad_sector_map( byte* buffer);
extern SectorMap get_bad_sector_entry( int segment_id );
extern void put_bad_sector_entry( int segment_id, SectorMap mask );
extern void add_segment_to_bad_sector_map( unsigned segment );
extern byte* find_end_of_bsm_list( byte* ptr, byte* limit );
extern void ftape_init_bsm( void );
extern unsigned ftape_get_seg_size( unsigned segment );

#endif




